﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WinGridFixedRowAndGrouping
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.HeaderClickAction = HeaderClickAction.Select;
            e.Layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;
            e.Layout.Override.FixedRowsLimit = 1;
            e.Layout.Override.FixedRowStyle = FixedRowStyle.Bottom;
        }

        private void ultraGrid1_InitializeRowsCollection(object sender, Infragistics.Win.UltraWinGrid.InitializeRowsCollectionEventArgs e)
        {
            // assumes no sorting on the grid
            // -> if sorting then you have to loop through each column in the band
            //    - and see if the IsGroupByColumn is set to true instead of check the 
            //    - count of the SortedColumns collection.
            if (e.Rows.Band.Key == "Orders" && e.Rows.Band.SortedColumns.Count < 1)
            {
                UltraGridRow row = null;
                foreach (UltraGridRow r in e.Rows)
                {
                    if (r.Tag.ToString() == "MyFooter")
                    {
                        row = r;
                        break;
                    }
                }

                if (row == null)
                {
                    // the next line causes InitializeRow to fire but we can supress it with an event manager as follows:
                    //this.ultraGrid1.EventManager.SetEnabled(GridEventIds.InitializeRow, false);
                    row = this.ultraGrid1.DisplayLayout.Bands[0].AddNew();
                    // don't forget to turn it back on...
                    //this.ultraGrid1.EventManager.SetEnabled(GridEventIds.InitializeRow, true);
                    row.Tag = "MyFooter";
                    row.Cells[0].Value = "Test";
                }

                row.Fixed = true;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //this.igData1.ReadXml("../../igData.xml");
            //this.igData1.AcceptChanges();
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {

        }
    }
}
